
/* File: _polkitauthorizationresult.c
 *
 * Generated by eggdbus-binding-tool 0.6. Do not edit.
 */

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif
#include <string.h>
#include "_polkitbindingstypes.h"
#include "_polkitbindings.h"
#include "_polkitauthorizationresult.h"

/**
 * SECTION:_polkitauthorizationresult
 * @title: _PolkitAuthorizationResult
 * @short_description: Authorization Results
 *
 * Describes the result of calling _polkit_authority_check_authorization().
 */

G_DEFINE_TYPE (_PolkitAuthorizationResult, _polkit_authorization_result, EGG_DBUS_TYPE_STRUCTURE);

static void
_polkit_authorization_result_init (_PolkitAuthorizationResult *instance)
{
}

static void
_polkit_authorization_result_class_init (_PolkitAuthorizationResultClass *klass)
{
}

/**
 * _polkit_authorization_result_get_is_authorized:
 * @instance: A #_PolkitAuthorizationResult.
 *
 * Gets element 0 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 *
 * Returns: TRUE if the given #_PolkitSubject is authorized for the given action.
 */
gboolean 
_polkit_authorization_result_get_is_authorized (_PolkitAuthorizationResult *instance)
{
  gboolean value;

  g_return_val_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance), 0);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                0, &value,
                -1);

  return value;
}

/**
 * _polkit_authorization_result_get_is_challenge:
 * @instance: A #_PolkitAuthorizationResult.
 *
 * Gets element 1 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 *
 * Returns: TRUE if the given #_PolkitSubject could be authorized if more information was provided, and %_POLKIT_CHECK_AUTHORIZATION_FLAGS_ALLOW_USER_INTERACTION wasn't passed or no suitable authentication agent was available.
 */
gboolean 
_polkit_authorization_result_get_is_challenge (_PolkitAuthorizationResult *instance)
{
  gboolean value;

  g_return_val_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance), 0);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                1, &value,
                -1);

  return value;
}

/**
 * _polkit_authorization_result_get_details:
 * @instance: A #_PolkitAuthorizationResult.
 *
 * Gets element 2 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 *
 * Returns: Details for the result or empty if not authorized. Known key/value-pairs include <literal>polkit.temporary_authorization_id</literal> (if the authorization is temporary, this is set to the opaque temporary authorization id), <literal>polkit.retains_authorization_after_challenge</literal> (Set to a non-empty string if the authorization will be retained after authentication (if is_challenge is TRUE)) and <literal>polkit.lockdown</literal> (set to a non-empty string if the action is locked down).
 */
EggDBusHashMap *
_polkit_authorization_result_get_details (_PolkitAuthorizationResult *instance)
{
  EggDBusHashMap *value;

  g_return_val_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance), NULL);

  egg_dbus_structure_get_element (EGG_DBUS_STRUCTURE (instance),
                2, &value,
                -1);

  return value;
}


/**
 * _polkit_authorization_result_set_is_authorized:
 * @instance: A #_PolkitAuthorizationResult.
 * @value: TRUE if the given #_PolkitSubject is authorized for the given action.
 *
 * Sets element 0 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 */
void
_polkit_authorization_result_set_is_authorized (_PolkitAuthorizationResult *instance, gboolean value)
{
  g_return_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                0, value,
                -1);
}

/**
 * _polkit_authorization_result_set_is_challenge:
 * @instance: A #_PolkitAuthorizationResult.
 * @value: TRUE if the given #_PolkitSubject could be authorized if more information was provided, and %_POLKIT_CHECK_AUTHORIZATION_FLAGS_ALLOW_USER_INTERACTION wasn't passed or no suitable authentication agent was available.
 *
 * Sets element 1 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 */
void
_polkit_authorization_result_set_is_challenge (_PolkitAuthorizationResult *instance, gboolean value)
{
  g_return_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                1, value,
                -1);
}

/**
 * _polkit_authorization_result_set_details:
 * @instance: A #_PolkitAuthorizationResult.
 * @value: Details for the result or empty if not authorized. Known key/value-pairs include <literal>polkit.temporary_authorization_id</literal> (if the authorization is temporary, this is set to the opaque temporary authorization id), <literal>polkit.retains_authorization_after_challenge</literal> (Set to a non-empty string if the authorization will be retained after authentication (if is_challenge is TRUE)) and <literal>polkit.lockdown</literal> (set to a non-empty string if the action is locked down).
 *
 * Sets element 2 of the #EggDBusStructure wrapped by #_PolkitAuthorizationResult.
 */
void
_polkit_authorization_result_set_details (_PolkitAuthorizationResult *instance, EggDBusHashMap *value)
{
  g_return_if_fail (_POLKIT_IS_AUTHORIZATION_RESULT (instance));

  egg_dbus_structure_set_element (EGG_DBUS_STRUCTURE (instance),
                2, value,
                -1);
}


/**
 * _polkit_authorization_result_new:
 * @is_authorized: TRUE if the given #_PolkitSubject is authorized for the given action.
 * @is_challenge: TRUE if the given #_PolkitSubject could be authorized if more information was provided, and %_POLKIT_CHECK_AUTHORIZATION_FLAGS_ALLOW_USER_INTERACTION wasn't passed or no suitable authentication agent was available.
 * @details: Details for the result or empty if not authorized. Known key/value-pairs include <literal>polkit.temporary_authorization_id</literal> (if the authorization is temporary, this is set to the opaque temporary authorization id), <literal>polkit.retains_authorization_after_challenge</literal> (Set to a non-empty string if the authorization will be retained after authentication (if is_challenge is TRUE)) and <literal>polkit.lockdown</literal> (set to a non-empty string if the action is locked down).
 *
 * Constructs a new #_PolkitAuthorizationResult.
 *
 * Returns: A #_PolkitAuthorizationResult.
 */
_PolkitAuthorizationResult *
_polkit_authorization_result_new (gboolean is_authorized, gboolean is_challenge, EggDBusHashMap *details)
{
  GValue *values;
  _PolkitAuthorizationResult *structure;

  values = g_new0 (GValue, 3);

  g_value_init (&(values[0]), G_TYPE_BOOLEAN);
  g_value_set_boolean (&(values[0]), is_authorized);

  g_value_init (&(values[1]), G_TYPE_BOOLEAN);
  g_value_set_boolean (&(values[1]), is_challenge);

  g_value_init (&(values[2]), EGG_DBUS_TYPE_HASH_MAP);
  g_value_set_object (&(values[2]), details);

  structure = _POLKIT_AUTHORIZATION_RESULT (g_object_new (_POLKIT_TYPE_AUTHORIZATION_RESULT, "signature", "(bba{ss})", "elements", values, NULL));

  return structure;
}

